diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
index 9a610d41ad..37107dc12b 100644
--- a/src/backend/bootstrap/bootstrap.c
+++ b/src/backend/bootstrap/bootstrap.c
@@ -453,7 +453,7 @@ boot_openrel(char *relname)
 			Form_pg_attribute at = attrtypes[i];
 
 			elog(DEBUG4, "create attribute %d name %s len %d num %d type %u",
-				 i, NameStr(at->attname), at->attlen, at->attnum,
+				 i, NameStr(at->attname), at->attlen, at->attphysnum,
 				 at->atttypid);
 		}
 	}
@@ -501,7 +501,7 @@ closerel(char *name)
  * ----------------
  */
 void
-DefineAttr(char *name, char *type, int attnum, int nullness)
+DefineAttr(char *name, char *type, int attphysnum, int nullness)
 {
 	Oid			typeoid;
 
@@ -511,46 +511,46 @@ DefineAttr(char *name, char *type, int attnum, int nullness)
 		closerel(NULL);
 	}
 
-	if (attrtypes[attnum] == NULL)
-		attrtypes[attnum] = AllocateAttribute();
-	MemSet(attrtypes[attnum], 0, ATTRIBUTE_FIXED_PART_SIZE);
+	if (attrtypes[attphysnum] == NULL)
+		attrtypes[attphysnum] = AllocateAttribute();
+	MemSet(attrtypes[attphysnum], 0, ATTRIBUTE_FIXED_PART_SIZE);
 
-	namestrcpy(&attrtypes[attnum]->attname, name);
-	elog(DEBUG4, "column %s %s", NameStr(attrtypes[attnum]->attname), type);
-	attrtypes[attnum]->attnum = attnum + 1;
+	namestrcpy(&attrtypes[attphysnum]->attname, name);
+	elog(DEBUG4, "column %s %s", NameStr(attrtypes[attphysnum]->attname), type);
+	attrtypes[attphysnum]->attphysnum = attphysnum + 1;
 
 	typeoid = gettype(type);
 
 	if (Typ != NIL)
 	{
-		attrtypes[attnum]->atttypid = Ap->am_oid;
-		attrtypes[attnum]->attlen = Ap->am_typ.typlen;
-		attrtypes[attnum]->attbyval = Ap->am_typ.typbyval;
-		attrtypes[attnum]->attalign = Ap->am_typ.typalign;
-		attrtypes[attnum]->attstorage = Ap->am_typ.typstorage;
-		attrtypes[attnum]->attcompression = InvalidCompressionMethod;
-		attrtypes[attnum]->attcollation = Ap->am_typ.typcollation;
+		attrtypes[attphysnum]->atttypid = Ap->am_oid;
+		attrtypes[attphysnum]->attlen = Ap->am_typ.typlen;
+		attrtypes[attphysnum]->attbyval = Ap->am_typ.typbyval;
+		attrtypes[attphysnum]->attalign = Ap->am_typ.typalign;
+		attrtypes[attphysnum]->attstorage = Ap->am_typ.typstorage;
+		attrtypes[attphysnum]->attcompression = InvalidCompressionMethod;
+		attrtypes[attphysnum]->attcollation = Ap->am_typ.typcollation;
 		/* if an array type, assume 1-dimensional attribute */
 		if (Ap->am_typ.typelem != InvalidOid && Ap->am_typ.typlen < 0)
-			attrtypes[attnum]->attndims = 1;
+			attrtypes[attphysnum]->attndims = 1;
 		else
-			attrtypes[attnum]->attndims = 0;
+			attrtypes[attphysnum]->attndims = 0;
 	}
 	else
 	{
-		attrtypes[attnum]->atttypid = TypInfo[typeoid].oid;
-		attrtypes[attnum]->attlen = TypInfo[typeoid].len;
-		attrtypes[attnum]->attbyval = TypInfo[typeoid].byval;
-		attrtypes[attnum]->attalign = TypInfo[typeoid].align;
-		attrtypes[attnum]->attstorage = TypInfo[typeoid].storage;
-		attrtypes[attnum]->attcompression = InvalidCompressionMethod;
-		attrtypes[attnum]->attcollation = TypInfo[typeoid].collation;
+		attrtypes[attphysnum]->atttypid = TypInfo[typeoid].oid;
+		attrtypes[attphysnum]->attlen = TypInfo[typeoid].len;
+		attrtypes[attphysnum]->attbyval = TypInfo[typeoid].byval;
+		attrtypes[attphysnum]->attalign = TypInfo[typeoid].align;
+		attrtypes[attphysnum]->attstorage = TypInfo[typeoid].storage;
+		attrtypes[attphysnum]->attcompression = InvalidCompressionMethod;
+		attrtypes[attphysnum]->attcollation = TypInfo[typeoid].collation;
 		/* if an array type, assume 1-dimensional attribute */
 		if (TypInfo[typeoid].elem != InvalidOid &&
-			attrtypes[attnum]->attlen < 0)
-			attrtypes[attnum]->attndims = 1;
+			attrtypes[attphysnum]->attlen < 0)
+			attrtypes[attphysnum]->attndims = 1;
 		else
-			attrtypes[attnum]->attndims = 0;
+			attrtypes[attphysnum]->attndims = 0;
 	}
 
 	/*
@@ -559,21 +559,21 @@ DefineAttr(char *name, char *type, int attnum, int nullness)
 	 * collation.  This is essential to allow template0 to be cloned with a
 	 * different database collation.
 	 */
-	if (OidIsValid(attrtypes[attnum]->attcollation))
-		attrtypes[attnum]->attcollation = C_COLLATION_OID;
+	if (OidIsValid(attrtypes[attphysnum]->attcollation))
+		attrtypes[attphysnum]->attcollation = C_COLLATION_OID;
 
-	attrtypes[attnum]->attstattarget = -1;
-	attrtypes[attnum]->attcacheoff = -1;
-	attrtypes[attnum]->atttypmod = -1;
-	attrtypes[attnum]->attislocal = true;
+	attrtypes[attphysnum]->attstattarget = -1;
+	attrtypes[attphysnum]->attcacheoff = -1;
+	attrtypes[attphysnum]->atttypmod = -1;
+	attrtypes[attphysnum]->attislocal = true;
 
 	if (nullness == BOOTCOL_NULL_FORCE_NOT_NULL)
 	{
-		attrtypes[attnum]->attnotnull = true;
+		attrtypes[attphysnum]->attnotnull = true;
 	}
 	else if (nullness == BOOTCOL_NULL_FORCE_NULL)
 	{
-		attrtypes[attnum]->attnotnull = false;
+		attrtypes[attphysnum]->attnotnull = false;
 	}
 	else
 	{
@@ -584,19 +584,19 @@ DefineAttr(char *name, char *type, int attnum, int nullness)
 		 * likewise fixed-width and not-null.  This corresponds to case where
 		 * column can be accessed directly via C struct declaration.
 		 */
-		if (attrtypes[attnum]->attlen > 0)
+		if (attrtypes[attphysnum]->attlen > 0)
 		{
 			int			i;
 
 			/* check earlier attributes */
-			for (i = 0; i < attnum; i++)
+			for (i = 0; i < attphysnum; i++)
 			{
 				if (attrtypes[i]->attlen <= 0 ||
 					!attrtypes[i]->attnotnull)
 					break;
 			}
-			if (i == attnum)
-				attrtypes[attnum]->attnotnull = true;
+			if (i == attphysnum)
+				attrtypes[attphysnum]->attnotnull = true;
 		}
 	}
 }
diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index 5f1726c095..3f5cbebcbc 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -137,7 +137,7 @@ static AclMode restrict_and_check_grant(bool is_grant, AclMode avail_goptions,
 										Oid objectId, Oid grantorId,
 										ObjectType objtype, const char *objname,
 										AttrNumber att_number, const char *colname);
-static AclMode pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attnum,
+static AclMode pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attphysnum,
 						  Oid roleid, AclMode mask, AclMaskHow how);
 static void recordExtensionInitPriv(Oid objoid, Oid classoid, int objsubid,
 									Acl *new_acl);
@@ -1578,18 +1578,18 @@ expand_col_privileges(List *colnames, Oid table_oid,
 	foreach(cell, colnames)
 	{
 		char	   *colname = strVal(lfirst(cell));
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
-		attnum = get_attnum(table_oid, colname);
-		if (attnum == InvalidAttrNumber)
+		attphysnum = get_attphysnum(table_oid, colname);
+		if (attphysnum == InvalidAttrNumber)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("column \"%s\" of relation \"%s\" does not exist",
 							colname, get_rel_name(table_oid))));
-		attnum -= FirstLowInvalidHeapAttributeNumber;
-		if (attnum <= 0 || attnum >= num_col_privileges)
+		attphysnum -= FirstLowInvalidHeapAttributeNumber;
+		if (attphysnum <= 0 || attphysnum >= num_col_privileges)
 			elog(ERROR, "column number out of range");	/* safety check */
-		col_privileges[attnum] |= this_privileges;
+		col_privileges[attphysnum] |= this_privileges;
 	}
 }
 
@@ -1623,7 +1623,7 @@ expand_all_col_privileges(Oid table_oid, Form_pg_class classForm,
 		if (classForm->relkind == RELKIND_VIEW && curr_att < 0)
 			continue;
 
-		attTuple = SearchSysCache2(ATTNUM,
+		attTuple = SearchSysCache2(ATTPHYSNUM,
 								   ObjectIdGetDatum(table_oid),
 								   Int16GetDatum(curr_att));
 		if (!HeapTupleIsValid(attTuple))
@@ -1648,7 +1648,7 @@ expand_all_col_privileges(Oid table_oid, Form_pg_class classForm,
  */
 static void
 ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
-					AttrNumber attnum, Oid ownerId, AclMode col_privileges,
+					AttrNumber attphysnum, Oid ownerId, AclMode col_privileges,
 					Relation attRelation, const Acl *old_rel_acl)
 {
 	HeapTuple	attr_tuple;
@@ -1670,20 +1670,20 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 	Oid		   *oldmembers;
 	Oid		   *newmembers;
 
-	attr_tuple = SearchSysCache2(ATTNUM,
+	attr_tuple = SearchSysCache2(ATTPHYSNUM,
 								 ObjectIdGetDatum(relOid),
-								 Int16GetDatum(attnum));
+								 Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(attr_tuple))
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relOid);
+			 attphysnum, relOid);
 	pg_attribute_tuple = (Form_pg_attribute) GETSTRUCT(attr_tuple);
 
 	/*
 	 * Get working copy of existing ACL. If there's no ACL, substitute the
 	 * proper default.
 	 */
-	aclDatum = SysCacheGetAttr(ATTNUM, attr_tuple, Anum_pg_attribute_attacl,
-							   &isNull);
+	aclDatum = SysCacheGetAttr(ATTPHYSNUM, attr_tuple,
+							   Anum_pg_attribute_attacl, &isNull);
 	if (isNull)
 	{
 		old_acl = acldefault(OBJECT_COLUMN, ownerId);
@@ -1726,7 +1726,7 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 								 (col_privileges == ACL_ALL_RIGHTS_COLUMN),
 								 col_privileges,
 								 relOid, grantorId, OBJECT_COLUMN,
-								 relname, attnum,
+								 relname, attphysnum,
 								 NameStr(pg_attribute_tuple->attname));
 
 	/*
@@ -1776,11 +1776,11 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 		CatalogTupleUpdate(attRelation, &newtuple->t_self, newtuple);
 
 		/* Update initial privileges for extensions */
-		recordExtensionInitPriv(relOid, RelationRelationId, attnum,
+		recordExtensionInitPriv(relOid, RelationRelationId, attphysnum,
 								ACL_NUM(new_acl) > 0 ? new_acl : NULL);
 
 		/* Update the shared dependency ACL info */
-		updateAclDependencies(RelationRelationId, relOid, attnum,
+		updateAclDependencies(RelationRelationId, relOid, attphysnum,
 							  ownerId,
 							  noldmembers, oldmembers,
 							  nnewmembers, newmembers);
@@ -3840,7 +3840,7 @@ aclcheck_error_type(AclResult aclerr, Oid typeOid)
  * Relay for the various pg_*_mask routines depending on object kind
  */
 static AclMode
-pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attnum, Oid roleid,
+pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attphysnum, Oid roleid,
 		   AclMode mask, AclMaskHow how)
 {
 	switch (objtype)
@@ -3848,7 +3848,7 @@ pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attnum, Oid roleid,
 		case OBJECT_COLUMN:
 			return
 				pg_class_aclmask(table_oid, roleid, mask, how) |
-				pg_attribute_aclmask(table_oid, attnum, roleid, mask, how);
+				pg_attribute_aclmask(table_oid, attphysnum, roleid, mask, how);
 		case OBJECT_TABLE:
 		case OBJECT_SEQUENCE:
 			return pg_class_aclmask(table_oid, roleid, mask, how);
@@ -3910,10 +3910,10 @@ pg_aclmask(ObjectType objtype, Oid table_oid, AttrNumber attnum, Oid roleid,
  * superuser-ness here.)
  */
 AclMode
-pg_attribute_aclmask(Oid table_oid, AttrNumber attnum, Oid roleid,
+pg_attribute_aclmask(Oid table_oid, AttrNumber attphysnum, Oid roleid,
 					 AclMode mask, AclMaskHow how)
 {
-	return pg_attribute_aclmask_ext(table_oid, attnum, roleid,
+	return pg_attribute_aclmask_ext(table_oid, attphysnum, roleid,
 									mask, how, NULL);
 }
 
@@ -3924,7 +3924,7 @@ pg_attribute_aclmask(Oid table_oid, AttrNumber attnum, Oid roleid,
  * callers to avoid the missing attribute ERROR when is_missing is non-NULL.
  */
 AclMode
-pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
+pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attphysnum, Oid roleid,
 						 AclMode mask, AclMaskHow how, bool *is_missing)
 {
 	AclMode		result;
@@ -3940,9 +3940,9 @@ pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
 	/*
 	 * First, get the column's ACL from its pg_attribute entry
 	 */
-	attTuple = SearchSysCache2(ATTNUM,
+	attTuple = SearchSysCache2(ATTPHYSNUM,
 							   ObjectIdGetDatum(table_oid),
-							   Int16GetDatum(attnum));
+							   Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(attTuple))
 	{
 		if (is_missing != NULL)
@@ -3955,7 +3955,7 @@ pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("attribute %d of relation with OID %u does not exist",
-							attnum, table_oid)));
+							attphysnum, table_oid)));
 	}
 
 	attributeForm = (Form_pg_attribute) GETSTRUCT(attTuple);
@@ -3974,10 +3974,10 @@ pg_attribute_aclmask_ext(Oid table_oid, AttrNumber attnum, Oid roleid,
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("attribute %d of relation with OID %u does not exist",
-							attnum, table_oid)));
+							attphysnum, table_oid)));
 	}
 
-	aclDatum = SysCacheGetAttr(ATTNUM, attTuple, Anum_pg_attribute_attacl,
+	aclDatum = SysCacheGetAttr(ATTPHYSNUM, attTuple, Anum_pg_attribute_attacl,
 							   &isNull);
 
 	/*
@@ -4875,10 +4875,10 @@ pg_type_aclmask(Oid type_oid, Oid roleid, AclMode mask, AclMaskHow how)
  * column are considered here.
  */
 AclResult
-pg_attribute_aclcheck(Oid table_oid, AttrNumber attnum,
+pg_attribute_aclcheck(Oid table_oid, AttrNumber attphysnum,
 					  Oid roleid, AclMode mode)
 {
-	return pg_attribute_aclcheck_ext(table_oid, attnum, roleid, mode, NULL);
+	return pg_attribute_aclcheck_ext(table_oid, attphysnum, roleid, mode, NULL);
 }
 
 
@@ -4889,10 +4889,10 @@ pg_attribute_aclcheck(Oid table_oid, AttrNumber attnum,
  * callers to avoid the missing attribute ERROR when is_missing is non-NULL.
  */
 AclResult
-pg_attribute_aclcheck_ext(Oid table_oid, AttrNumber attnum,
+pg_attribute_aclcheck_ext(Oid table_oid, AttrNumber attphysnum,
 						  Oid roleid, AclMode mode, bool *is_missing)
 {
-	if (pg_attribute_aclmask_ext(table_oid, attnum, roleid, mode,
+	if (pg_attribute_aclmask_ext(table_oid, attphysnum, roleid, mode,
 								 ACLMASK_ANY, is_missing) != 0)
 		return ACLCHECK_OK;
 	else
@@ -4953,7 +4953,7 @@ pg_attribute_aclcheck_all(Oid table_oid, Oid roleid, AclMode mode,
 		HeapTuple	attTuple;
 		AclMode		attmask;
 
-		attTuple = SearchSysCache2(ATTNUM,
+		attTuple = SearchSysCache2(ATTPHYSNUM,
 								   ObjectIdGetDatum(table_oid),
 								   Int16GetDatum(curr_att));
 		if (!HeapTupleIsValid(attTuple))
@@ -6025,7 +6025,7 @@ recordExtObjInitPriv(Oid objoid, Oid classoid)
 				HeapTuple	attTuple;
 				Datum		attaclDatum;
 
-				attTuple = SearchSysCache2(ATTNUM,
+				attTuple = SearchSysCache2(ATTPHYSNUM,
 										   ObjectIdGetDatum(objoid),
 										   Int16GetDatum(curr_att));
 
@@ -6039,7 +6039,7 @@ recordExtObjInitPriv(Oid objoid, Oid classoid)
 					continue;
 				}
 
-				attaclDatum = SysCacheGetAttr(ATTNUM, attTuple,
+				attaclDatum = SysCacheGetAttr(ATTPHYSNUM, attTuple,
 											  Anum_pg_attribute_attacl,
 											  &isNull);
 
@@ -6318,7 +6318,7 @@ removeExtObjInitPriv(Oid objoid, Oid classoid)
 			{
 				HeapTuple	attTuple;
 
-				attTuple = SearchSysCache2(ATTNUM,
+				attTuple = SearchSysCache2(ATTPHYSNUM,
 										   ObjectIdGetDatum(objoid),
 										   Int16GetDatum(curr_att));
 
diff --git a/src/backend/catalog/catalog.c b/src/backend/catalog/catalog.c
index e784538aae..44b4b03cac 100644
--- a/src/backend/catalog/catalog.c
+++ b/src/backend/catalog/catalog.c
@@ -628,7 +628,7 @@ pg_nextoid(PG_FUNCTION_ARGS)
 						NameStr(*attname), RelationGetRelationName(rel))));
 
 	attform = ((Form_pg_attribute) GETSTRUCT(atttuple));
-	attno = attform->attnum;
+	attno = attform->attphysnum;
 
 	if (attform->atttypid != OIDOID)
 		ereport(ERROR,
diff --git a/src/backend/catalog/genbki.pl b/src/backend/catalog/genbki.pl
index 17b2c5e3f3..f1d33dd949 100644
--- a/src/backend/catalog/genbki.pl
+++ b/src/backend/catalog/genbki.pl
@@ -508,10 +508,10 @@ EOM
 	print $bki "\n (\n";
 	my $schema = $catalog->{columns};
 	my %attnames;
-	my $attnum = 0;
+	my $attphysnum = 0;
 	foreach my $column (@$schema)
 	{
-		$attnum++;
+		$attphysnum++;
 		my $attname = $column->{name};
 		my $atttype = $column->{type};
 
@@ -537,12 +537,12 @@ EOM
 		}
 
 		# Emit Anum_* constants
-		printf $def "#define Anum_%s_%s %s\n", $catname, $attname, $attnum;
+		printf $def "#define Anum_%s_%s %s\n", $catname, $attname, $attphysnum;
 	}
 	print $bki "\n )\n";
 
 	# Emit Natts_* constant
-	print $def "\n#define Natts_$catname $attnum\n\n";
+	print $def "\n#define Natts_$catname $attphysnum\n\n";
 
 	# Emit client code copied from source header
 	foreach my $line (@{ $catalog->{client_code} })
@@ -845,13 +845,13 @@ sub gen_pg_attribute
 		push @tables_needing_macros, $table_name;
 
 		# Generate entries for user attributes.
-		my $attnum          = 0;
+		my $attphysnum          = 0;
 		my $priorfixedwidth = 1;
 		foreach my $attr (@{ $table->{columns} })
 		{
-			$attnum++;
+			$attphysnum++;
 			my %row;
-			$row{attnum}   = $attnum;
+			$row{attphysnum}   = $attphysnum;
 			$row{attrelid} = $table->{relation_oid};
 
 			morph_row_for_pgattr(\%row, $schema, $attr, $priorfixedwidth);
@@ -875,7 +875,7 @@ sub gen_pg_attribute
 		# We only need postgres.bki entries, not schemapg.h entries.
 		if ($table->{bootstrap})
 		{
-			$attnum = 0;
+			$attphysnum = 0;
 			my @SYS_ATTRS = (
 				{ name => 'ctid',     type => 'tid' },
 				{ name => 'xmin',     type => 'xid' },
@@ -885,9 +885,9 @@ sub gen_pg_attribute
 				{ name => 'tableoid', type => 'oid' });
 			foreach my $attr (@SYS_ATTRS)
 			{
-				$attnum--;
+				$attphysnum--;
 				my %row;
-				$row{attnum}        = $attnum;
+				$row{attphysnum}        = $attphysnum;
 				$row{attrelid}      = $table->{relation_oid};
 				$row{attstattarget} = '0';
 
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index 1803194db9..ed9929e67a 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -142,7 +142,7 @@ static const FormData_pg_attribute a1 = {
 	.attname = {"ctid"},
 	.atttypid = TIDOID,
 	.attlen = sizeof(ItemPointerData),
-	.attnum = SelfItemPointerAttributeNumber,
+	.attphysnum = SelfItemPointerAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = false,
@@ -156,7 +156,7 @@ static const FormData_pg_attribute a2 = {
 	.attname = {"xmin"},
 	.atttypid = XIDOID,
 	.attlen = sizeof(TransactionId),
-	.attnum = MinTransactionIdAttributeNumber,
+	.attphysnum = MinTransactionIdAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = true,
@@ -170,7 +170,7 @@ static const FormData_pg_attribute a3 = {
 	.attname = {"cmin"},
 	.atttypid = CIDOID,
 	.attlen = sizeof(CommandId),
-	.attnum = MinCommandIdAttributeNumber,
+	.attphysnum = MinCommandIdAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = true,
@@ -184,7 +184,7 @@ static const FormData_pg_attribute a4 = {
 	.attname = {"xmax"},
 	.atttypid = XIDOID,
 	.attlen = sizeof(TransactionId),
-	.attnum = MaxTransactionIdAttributeNumber,
+	.attphysnum = MaxTransactionIdAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = true,
@@ -198,7 +198,7 @@ static const FormData_pg_attribute a5 = {
 	.attname = {"cmax"},
 	.atttypid = CIDOID,
 	.attlen = sizeof(CommandId),
-	.attnum = MaxCommandIdAttributeNumber,
+	.attphysnum = MaxCommandIdAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = true,
@@ -218,7 +218,7 @@ static const FormData_pg_attribute a6 = {
 	.attname = {"tableoid"},
 	.atttypid = OIDOID,
 	.attlen = sizeof(Oid),
-	.attnum = TableOidAttributeNumber,
+	.attphysnum = TableOidAttributeNumber,
 	.attcacheoff = -1,
 	.atttypmod = -1,
 	.attbyval = true,
@@ -731,7 +731,7 @@ InsertPgAttributeTuples(Relation pg_attribute_rel,
 		slot[slotCount]->tts_values[Anum_pg_attribute_atttypid - 1] = ObjectIdGetDatum(attrs->atttypid);
 		slot[slotCount]->tts_values[Anum_pg_attribute_attstattarget - 1] = Int32GetDatum(attrs->attstattarget);
 		slot[slotCount]->tts_values[Anum_pg_attribute_attlen - 1] = Int16GetDatum(attrs->attlen);
-		slot[slotCount]->tts_values[Anum_pg_attribute_attnum - 1] = Int16GetDatum(attrs->attnum);
+		slot[slotCount]->tts_values[Anum_pg_attribute_attphysnum - 1] = Int16GetDatum(attrs->attphysnum);
 		slot[slotCount]->tts_values[Anum_pg_attribute_attndims - 1] = Int32GetDatum(attrs->attndims);
 		slot[slotCount]->tts_values[Anum_pg_attribute_attcacheoff - 1] = Int32GetDatum(-1);
 		slot[slotCount]->tts_values[Anum_pg_attribute_atttypmod - 1] = Int32GetDatum(attrs->atttypmod);
@@ -1578,7 +1578,7 @@ DeleteAttributeTuples(Oid relid)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relid));
 
-	scan = systable_beginscan(attrel, AttributeRelidNumIndexId, true,
+	scan = systable_beginscan(attrel, AttributeRelidPhysNumIndexId, true,
 							  NULL, 1, key);
 
 	/* Delete all the matching tuples */
@@ -1615,11 +1615,11 @@ DeleteSystemAttributeTuples(Oid relid)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relid));
 	ScanKeyInit(&key[1],
-				Anum_pg_attribute_attnum,
+				Anum_pg_attribute_attphysnum,
 				BTLessEqualStrategyNumber, F_INT2LE,
 				Int16GetDatum(0));
 
-	scan = systable_beginscan(attrel, AttributeRelidNumIndexId, true,
+	scan = systable_beginscan(attrel, AttributeRelidPhysNumIndexId, true,
 							  NULL, 2, key);
 
 	/* Delete all the matching tuples */
@@ -1640,7 +1640,7 @@ DeleteSystemAttributeTuples(Oid relid)
  * is handled by dependency.c.)
  */
 void
-RemoveAttributeById(Oid relid, AttrNumber attnum)
+RemoveAttributeById(Oid relid, AttrNumber attphysnum)
 {
 	Relation	rel;
 	Relation	attr_rel;
@@ -1658,15 +1658,15 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 
 	attr_rel = table_open(AttributeRelationId, RowExclusiveLock);
 
-	tuple = SearchSysCacheCopy2(ATTNUM,
+	tuple = SearchSysCacheCopy2(ATTPHYSNUM,
 								ObjectIdGetDatum(relid),
-								Int16GetDatum(attnum));
+								Int16GetDatum(attphysnum));
 	if (!HeapTupleIsValid(tuple))	/* shouldn't happen */
 		elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-			 attnum, relid);
+			 attphysnum, relid);
 	attStruct = (Form_pg_attribute) GETSTRUCT(tuple);
 
-	if (attnum < 0)
+	if (attphysnum < 0)
 	{
 		/* System attribute (probably OID) ... just delete the row */
 
@@ -1703,7 +1703,7 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 		 * Change the column name to something that isn't likely to conflict
 		 */
 		snprintf(newattname, sizeof(newattname),
-				 "........pg.dropped.%d........", attnum);
+				 "........pg.dropped.%d........", attphysnum);
 		namestrcpy(&(attStruct->attname), newattname);
 
 		/* clear the missing value if any */
@@ -1740,8 +1740,8 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 
 	table_close(attr_rel, RowExclusiveLock);
 
-	if (attnum > 0)
-		RemoveStatistics(relid, attnum);
+	if (attphysnum > 0)
+		RemoveStatistics(relid, attphysnum);
 
 	relation_close(rel, NoLock);
 }
@@ -1941,7 +1941,7 @@ RelationClearMissing(Relation rel)
 	Relation	attr_rel;
 	Oid			relid = RelationGetRelid(rel);
 	int			natts = RelationGetNumberOfAttributes(rel);
-	int			attnum;
+	int			attphysnum;
 	Datum		repl_val[Natts_pg_attribute];
 	bool		repl_null[Natts_pg_attribute];
 	bool		repl_repl[Natts_pg_attribute];
@@ -1964,14 +1964,14 @@ RelationClearMissing(Relation rel)
 	attr_rel = table_open(AttributeRelationId, RowExclusiveLock);
 
 	/* process each non-system attribute, including any dropped columns */
-	for (attnum = 1; attnum <= natts; attnum++)
+	for (attphysnum = 1; attphysnum <= natts; attphysnum++)
 	{
-		tuple = SearchSysCache2(ATTNUM,
+		tuple = SearchSysCache2(ATTPHYSNUM,
 								ObjectIdGetDatum(relid),
-								Int16GetDatum(attnum));
+								Int16GetDatum(attphysnum));
 		if (!HeapTupleIsValid(tuple))	/* shouldn't happen */
 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-				 attnum, relid);
+				 attphysnum, relid);
 
 		attrtuple = (Form_pg_attribute) GETSTRUCT(tuple);
 
@@ -2201,7 +2201,7 @@ StoreConstraints(Relation rel, List *cooked_constraints, bool is_internal)
 		switch (con->contype)
 		{
 			case CONSTR_DEFAULT:
-				con->conoid = StoreAttrDefault(rel, con->attnum, con->expr,
+				con->conoid = StoreAttrDefault(rel, con->attphysnum, con->expr,
 											   is_internal, false);
 				break;
 			case CONSTR_CHECK:
@@ -2301,7 +2301,7 @@ AddRelationNewConstraints(Relation rel,
 	foreach(cell, newColDefaults)
 	{
 		RawColumnDefault *colDef = (RawColumnDefault *) lfirst(cell);
-		Form_pg_attribute atp = TupleDescAttr(rel->rd_att, colDef->attnum - 1);
+		Form_pg_attribute atp = TupleDescAttr(rel->rd_att, colDef->attphysnum - 1);
 		Oid			defOid;
 
 		expr = cookDefault(pstate, colDef->raw_default,
@@ -2331,14 +2331,14 @@ AddRelationNewConstraints(Relation rel,
 		if (colDef->missingMode && contain_volatile_functions((Node *) expr))
 			colDef->missingMode = false;
 
-		defOid = StoreAttrDefault(rel, colDef->attnum, expr, is_internal,
+		defOid = StoreAttrDefault(rel, colDef->attphysnum, expr, is_internal,
 								  colDef->missingMode);
 
 		cooked = (CookedConstraint *) palloc(sizeof(CookedConstraint));
 		cooked->contype = CONSTR_DEFAULT;
 		cooked->conoid = defOid;
 		cooked->name = NULL;
-		cooked->attnum = colDef->attnum;
+		cooked->attphysnum = colDef->attphysnum;
 		cooked->expr = expr;
 		cooked->skip_validation = false;
 		cooked->is_local = is_local;
@@ -2469,7 +2469,7 @@ AddRelationNewConstraints(Relation rel,
 		cooked->contype = CONSTR_CHECK;
 		cooked->conoid = constrOid;
 		cooked->name = ccname;
-		cooked->attnum = 0;
+		cooked->attphysnum = 0;
 		cooked->expr = expr;
 		cooked->skip_validation = cdef->skip_validation;
 		cooked->is_local = is_local;
@@ -2695,23 +2695,23 @@ check_nested_generated_walker(Node *node, void *context)
 	{
 		Var		   *var = (Var *) node;
 		Oid			relid;
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 
 		relid = rt_fetch(var->varno, pstate->p_rtable)->relid;
 		if (!OidIsValid(relid))
 			return false;		/* XXX shouldn't we raise an error? */
 
-		attnum = var->varattno;
+		attphysnum = var->varattno;
 
-		if (attnum > 0 && get_attgenerated(relid, attnum))
+		if (attphysnum > 0 && get_attgenerated(relid, attphysnum))
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
 					 errmsg("cannot use generated column \"%s\" in column generation expression",
-							get_attname(relid, attnum, false)),
+							get_attname(relid, attphysnum, false)),
 					 errdetail("A generated column cannot reference another generated column."),
 					 parser_errposition(pstate, var->location)));
 		/* A whole-row Var is necessarily self-referential, so forbid it */
-		if (attnum == 0)
+		if (attphysnum == 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
 					 errmsg("cannot use whole-row variable in column generation expression"),
@@ -2899,11 +2899,11 @@ CopyStatistics(Oid fromrelid, Oid torelid)
 /*
  * RemoveStatistics --- remove entries in pg_statistic for a rel or column
  *
- * If attnum is zero, remove all entries for rel; else remove only the one(s)
+ * If attphysnum is zero, remove all entries for rel; else remove only the one(s)
  * for that column.
  */
 void
-RemoveStatistics(Oid relid, AttrNumber attnum)
+RemoveStatistics(Oid relid, AttrNumber attphysnum)
 {
 	Relation	pgstatistic;
 	SysScanDesc scan;
@@ -2918,21 +2918,21 @@ RemoveStatistics(Oid relid, AttrNumber attnum)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relid));
 
-	if (attnum == 0)
+	if (attphysnum == 0)
 		nkeys = 1;
 	else
 	{
 		ScanKeyInit(&key[1],
 					Anum_pg_statistic_staattnum,
 					BTEqualStrategyNumber, F_INT2EQ,
-					Int16GetDatum(attnum));
+					Int16GetDatum(attphysnum));
 		nkeys = 2;
 	}
 
 	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumInhIndexId, true,
 							  NULL, nkeys, key);
 
-	/* we must loop even when attnum != 0, in case of inherited stats */
+	/* we must loop even when attphysnum != 0, in case of inherited stats */
 	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
 		CatalogTupleDelete(pgstatistic, &tuple->t_self);
 
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index bdd3c34841..c514e3b622 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -231,25 +231,25 @@ index_check_primary_key(Relation heapRel,
 	 */
 	for (i = 0; i < indexInfo->ii_NumIndexKeyAttrs; i++)
 	{
-		AttrNumber	attnum = indexInfo->ii_IndexAttrNumbers[i];
+		AttrNumber	attphysnum = indexInfo->ii_IndexAttrNumbers[i];
 		HeapTuple	atttuple;
 		Form_pg_attribute attform;
 
-		if (attnum == 0)
+		if (attphysnum == 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 					 errmsg("primary keys cannot be expressions")));
 
 		/* System attributes are never null, so no need to check */
-		if (attnum < 0)
+		if (attphysnum < 0)
 			continue;
 
-		atttuple = SearchSysCache2(ATTNUM,
+		atttuple = SearchSysCache2(ATTPHYSNUM,
 								   ObjectIdGetDatum(RelationGetRelid(heapRel)),
-								   Int16GetDatum(attnum));
+								   Int16GetDatum(attphysnum));
 		if (!HeapTupleIsValid(atttuple))
 			elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-				 attnum, RelationGetRelid(heapRel));
+				 attphysnum, RelationGetRelid(heapRel));
 		attform = (Form_pg_attribute) GETSTRUCT(atttuple);
 
 		if (!attform->attnotnull)
@@ -310,7 +310,7 @@ ConstructTupleDescriptor(Relation heapRelation,
 		Oid			keyType;
 
 		MemSet(to, 0, ATTRIBUTE_FIXED_PART_SIZE);
-		to->attnum = i + 1;
+		to->attphysnum = i + 1;
 		to->attstattarget = -1;
 		to->attcacheoff = -1;
 		to->attislocal = true;
@@ -1770,7 +1770,7 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 					Anum_pg_attribute_attrelid,
 					BTEqualStrategyNumber, F_OIDEQ,
 					ObjectIdGetDatum(newIndexId));
-		scan = systable_beginscan(pg_attribute, AttributeRelidNumIndexId,
+		scan = systable_beginscan(pg_attribute, AttributeRelidPhysNumIndexId,
 								  true, NULL, 1, key);
 
 		while (HeapTupleIsValid((attrTuple = systable_getnext(scan))))
@@ -1789,7 +1789,7 @@ index_concurrently_swap(Oid newIndexId, Oid oldIndexId, const char *oldName)
 			/*
 			 * Get attstattarget from the old index and refresh the new value.
 			 */
-			attstattarget = get_attstattarget(oldIndexId, att->attnum);
+			attstattarget = get_attstattarget(oldIndexId, att->attphysnum);
 
 			/* no need for a refresh if both match */
 			if (attstattarget == att->attstattarget)
diff --git a/src/backend/catalog/indexing.c b/src/backend/catalog/indexing.c
index 0b92093322..6c5052c0de 100644
--- a/src/backend/catalog/indexing.c
+++ b/src/backend/catalog/indexing.c
@@ -191,11 +191,11 @@ CatalogTupleCheckConstraints(Relation heapRel, HeapTuple tup)
 		TupleDesc	tupdesc = RelationGetDescr(heapRel);
 		bits8	   *bp = tup->t_data->t_bits;
 
-		for (int attnum = 0; attnum < tupdesc->natts; attnum++)
+		for (int attphysnum = 0; attphysnum < tupdesc->natts; attphysnum++)
 		{
-			Form_pg_attribute thisatt = TupleDescAttr(tupdesc, attnum);
+			Form_pg_attribute thisatt = TupleDescAttr(tupdesc, attphysnum);
 
-			Assert(!(thisatt->attnotnull && att_isnull(attnum, bp)));
+			Assert(!(thisatt->attnotnull && att_isnull(attphysnum, bp)));
 		}
 	}
 }
